// This code was generated by a tool.
// Processing tool available at https://github.com/mezoni/peg

import 'package:peg/expressions.dart';
import 'package:peg/grammar.dart';
import 'package:peg/production_rule.dart';

int _escape(int c) {
  switch (c) {
    case 110:
      return 10;      
    case 114:
      return 13;      
    case 116:
      return 9;      
  }    
  return c;
}

Expression _prefix(dynamic prefix, Expression expression, String action) {  
  switch (prefix) {
    case '&':
     expression = new AndPredicateExpression(expression);
     break;
    case '!':
     expression = new NotPredicateExpression(expression);
     break;        
  }
  expression.action = action;
  return expression;
}

Expression _suffix(String suffix, Expression expression) {
  switch (suffix) {
    case '?':
      return new OptionalExpression(expression);
    case '*':
      return  new ZeroOrMoreExpression(expression);
    case '+':
      return new OneOrMoreExpression(expression);        
  }
  return expression;
}
class PegParser {
  static const int EOF = -1;
  static final List<String> _ascii = new List<String>.generate(128, (c) => new String.fromCharCode(c));
  static final List<bool> _lookahead = _unmap([0x14800013, 0x7e000000, 0x7d0fffff, 0x38ffffff, 0x7f800010, 0x7f47ffff, 0x30fffff, 0x7ff80001, 0x7ff47fff, 0x1ffffff, 0x7fffffe, 0xffffffd]);
  // '\"', '\'', '-', '[', '\\', ']', 'n', 'r', 't'
  static final List<bool> _mapping0 = _unmap([0x821, 0x1c000000, 0x144000]);
  // '\n', '\r'
  static final List<bool> _mapping1 = _unmap([0x9]);
  // '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'a', 'b', 'c', 'd', 'e', 'f'
  static final List<bool> _mapping2 = _unmap([0x7e03ff, 0xfc0000]);
  // 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '_', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'
  static final List<bool> _mapping3 = _unmap([0x43ffffff, 0x7fffffe]);
  // '\t', ' '
  static final List<bool> _mapping4 = _unmap([0x800001]);
  // "\r\n"
  static final List<int> _strings0 = <int>[13, 10];
  // "%{"
  static final List<int> _strings1 = <int>[37, 123];
  // "}%"
  static final List<int> _strings2 = <int>[125, 37];
  // "\u"
  static final List<int> _strings3 = <int>[92, 117];
  // "<-"
  static final List<int> _strings4 = <int>[60, 45];
  static final List<String> _expect0 = <String>["&"];
  static final List<String> _expect1 = <String>["{"];
  static final List<String> _expect2 = <String>[null, "{"];
  static final List<String> _expect3 = <String>[")"];
  static final List<String> _expect4 = <String>["EOL"];
  static final List<String> _expect5 = <String>[null];
  static final List<String> _expect6 = <String>["#"];
  static final List<String> _expect7 = <String>["\\u"];
  static final List<String> _expect8 = <String>[null, "\\", "\\u"];
  static final List<String> _expect9 = <String>["["];
  static final List<String> _expect10 = <String>["."];
  static final List<String> _expect11 = <String>["IDENTIFIER"];
  static final List<String> _expect12 = <String>["<-"];
  static final List<String> _expect13 = <String>["\"", "\'", "(", ".", "IDENTIFIER", "["];
  static final List<String> _expect14 = <String>["EOF"];
  static final List<String> _expect15 = <String>["/"];
  static final List<String> _expect16 = <String>["%{"];
  static final List<String> _expect17 = <String>["IDENT_START"];
  static final List<String> _expect18 = <String>["IDENT_CONT"];
  static final List<String> _expect19 = <String>["\"", "\'"];
  static final List<String> _expect20 = <String>["!"];
  static final List<String> _expect21 = <String>["("];
  static final List<String> _expect22 = <String>["+"];
  static final List<String> _expect23 = <String>["!", "&"];
  static final List<String> _expect24 = <String>["?"];
  static final List<String> _expect25 = <String>["SPACE"];
  static final List<String> _expect26 = <String>["#", "SPACE"];
  static final List<String> _expect27 = <String>["SPACING"];
  static final List<String> _expect28 = <String>["*"];
  static final List<String> _expect29 = <String>["*", "+", "?"];
  List _cache;
  int _cachePos;
  List<int> _cacheRule;
  List<int> _cacheState;
  int _ch;
  int _column;
  int _cursor;
  List<String> _expected;
  int _failurePos;
  int _inputLen;
  int _line;
  List<int> _runes;
  bool success;
  int _testing;
  String _token;
  int _tokenLevel;
  int _tokenStart;
  
  PegParser(String text) {
    if (text == null) {
      throw new ArgumentError('text: $text');
    }    
    _runes = _toRunes(text);
    _inputLen = _runes.length;
    if (_inputLen >= 0x3fffffe8 / 32) {
      throw new StateError('File size to big: $_inputLen');
    }  
    reset(0);    
  }
  
  int get column { 
    if (_column == -1) { 
      _calculatePos(_failurePos); 
    } 
    return _column;       
  } 
   
  int get line { 
    if (_line == -1) { 
      _calculatePos(_failurePos); 
    } 
    return _line;       
  } 
   
  dynamic _parse_AND() {
    // TERMINAL
    // AND <- "&" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "&";  
      _tokenStart = _cursor;  
    }  
    // "&" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "&"
      $$ = _matchChar(38, '&');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "&"
        final $1 = seq[0];
        // SPACING
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "&"
      _failure(_expect0);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Action() {
    // NONTERMINAL
    // Action <- "{" ActionBody* "}" SPACING
    var $$;
    // "{" ActionBody* "}" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "{"
      $$ = _matchChar(123, '{');
      if (!success) break;
      var seq = new List(4)..[0] = $$;
      // ActionBody*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // ActionBody
        $$ = _parse_ActionBody();
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      // "}"
      $$ = _matchChar(125, '}');
      if (!success) break;
      seq[2] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[3] = $$;
      $$ = seq;
      if (success) {    
        // "{"
        final $1 = seq[0];
        // ActionBody*
        final $2 = seq[1];
        // "}"
        final $3 = seq[2];
        // SPACING
        final $4 = seq[3];
        $$ = _normalize([$1, $2, $3, $4]).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "{"
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_ActionBody() {
    // NONTERMINAL
    // ActionBody <- Action / !"}" .
    var $$;
    // Action / !"}" .
    while (true) {
      // Action
      $$ = null;
      success = _ch == 123; // '{'
      // Lookahead (Action)
      if (success) $$ = _parse_Action();
      if (!success) {
        // Expected: "{"
        if (_cursor > _testing) _failure(_expect1);  
      }
      if (success) break;
      // !"}" .
      var ch0 = _ch, pos0 = _cursor;
      while (true) {  
        // !"}"
        var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
        _testing = _inputLen + 1;
        // "}"
        $$ = _matchChar(125, '}');
        _ch = ch1;
        _cursor = pos1; 
        _testing = testing0;
        $$ = null;
        success = !success;
        if (!success) break;
        var seq = new List(2)..[0] = $$;
        // .
        $$ = _matchAny();
        if (!success) break;
        seq[1] = $$;
        $$ = seq;
        if (success) {    
          // !"}"
          final $1 = seq[0];
          // .
          final $2 = seq[1];
          $$ = $2;    
        }
        break;  
      }
      if (!success) {
        _ch = ch0;
        _cursor = pos0;
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "{", null
      _failure(_expect2);
    }
    return $$;
  }
  
  dynamic _parse_CLOSE() {
    // TERMINAL
    // CLOSE <- ")" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = ")";  
      _tokenStart = _cursor;  
    }  
    // ")" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // ")"
      $$ = _matchChar(41, ')');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: ")"
      _failure(_expect3);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_COMMENT() {
    // TERMINAL
    // COMMENT <- "#" (!EOL .)* EOL?
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "#";  
      _tokenStart = _cursor;  
    }  
    // "#" (!EOL .)* EOL?
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "#"
      $$ = _matchChar(35, '#');
      if (!success) break;
      var seq = new List(3)..[0] = $$;
      // (!EOL .)*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // !EOL .
        var ch1 = _ch, pos1 = _cursor;
        while (true) {  
          // !EOL
          var ch2 = _ch, pos2 = _cursor, testing1 = _testing; 
          _testing = _inputLen + 1;
          // EOL
          $$ = null;
          success = _ch >= 10 && _ch <= 13 && _lookahead[_ch + -9];
          // Lookahead (EOL)
          if (success) $$ = _parse_EOL();    
          if (!success) {    
            // Expected: "EOL"    
            if (_cursor > _testing) _failure(_expect4);
          }
          _ch = ch2;
          _cursor = pos2; 
          _testing = testing1;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          // .
          $$ = _matchAny();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          break;  
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        if (!success && _cursor > _testing) {
          // Expected: null
          _failure(_expect5);
        }
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      // EOL?
      var testing2 = _testing;
      _testing = _cursor;
      // EOL
      $$ = null;
      success = _ch >= 10 && _ch <= 13 && _lookahead[_ch + -9];
      // Lookahead (EOL)
      if (success) $$ = _parse_EOL();    
      if (!success) {    
        // Expected: "EOL"    
        if (_cursor > _testing) _failure(_expect4);
      }
      success = true; 
      _testing = testing2;
      if (!success) break;
      seq[2] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "#"
      _failure(_expect6);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Char() {
    // NONTERMINAL
    // Char <- "\\" ["'\-\[-\]nrt] / HEX_NUMBER / !"\\" !EOL .
    var $$;
    // "\\" ["'\-\[-\]nrt] / HEX_NUMBER / !"\\" !EOL .
    while (true) {
      // "\\" ["'\-\[-\]nrt]
      var ch0 = _ch, pos0 = _cursor;
      while (true) {  
        // "\\"
        $$ = _matchChar(92, '\\');
        if (!success) break;
        var seq = new List(2)..[0] = $$;
        // ["'\-\[-\]nrt]
        $$ = _matchMapping(34, 116, _mapping0);
        if (!success) break;
        seq[1] = $$;
        $$ = seq;
        if (success) {    
          // "\\"
          final $1 = seq[0];
          // ["'\-\[-\]nrt]
          final $2 = seq[1];
          $$ = _escape($2.codeUnitAt(0));    
        }
        break;  
      }
      if (!success) {
        _ch = ch0;
        _cursor = pos0;
      }
      if (success) break;
      // HEX_NUMBER
      $$ = null;
      success = _ch == 92; // '\'
      // Lookahead (HEX_NUMBER)
      if (success) $$ = _parse_HEX_NUMBER();
      if (!success) {
        // Expected: "\\u"
        if (_cursor > _testing) _failure(_expect7);  
      }
      if (success) break;
      // !"\\" !EOL .
      var ch1 = _ch, pos1 = _cursor;
      while (true) {  
        // !"\\"
        var ch2 = _ch, pos2 = _cursor, testing0 = _testing; 
        _testing = _inputLen + 1;
        // "\\"
        $$ = _matchChar(92, '\\');
        _ch = ch2;
        _cursor = pos2; 
        _testing = testing0;
        $$ = null;
        success = !success;
        if (!success) break;
        var seq = new List(3)..[0] = $$;
        // !EOL
        var ch3 = _ch, pos3 = _cursor, testing1 = _testing; 
        _testing = _inputLen + 1;
        // EOL
        $$ = null;
        success = _ch >= 10 && _ch <= 13 && _lookahead[_ch + -9];
        // Lookahead (EOL)
        if (success) $$ = _parse_EOL();    
        if (!success) {    
          // Expected: "EOL"    
          if (_cursor > _testing) _failure(_expect4);
        }
        _ch = ch3;
        _cursor = pos3; 
        _testing = testing1;
        $$ = null;
        success = !success;
        if (!success) break;
        seq[1] = $$;
        // .
        $$ = _matchAny();
        if (!success) break;
        seq[2] = $$;
        $$ = seq;
        if (success) {    
          // !"\\"
          final $1 = seq[0];
          // !EOL
          final $2 = seq[1];
          // .
          final $3 = seq[2];
          $$ = _toRune($3);    
        }
        break;  
      }
      if (!success) {
        _ch = ch1;
        _cursor = pos1;
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "\\", "\\u", null
      _failure(_expect8);
    }
    return $$;
  }
  
  dynamic _parse_Class() {
    // NONTERMINAL
    // Class <- "[" (!"]" Range)* "]" SPACING
    var $$;
    // "[" (!"]" Range)* "]" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "["
      $$ = _matchChar(91, '[');
      if (!success) break;
      var seq = new List(4)..[0] = $$;
      // (!"]" Range)*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // !"]" Range
        var ch1 = _ch, pos1 = _cursor;
        while (true) {  
          // !"]"
          var ch2 = _ch, pos2 = _cursor, testing1 = _testing; 
          _testing = _inputLen + 1;
          // "]"
          $$ = _matchChar(93, ']');
          _ch = ch2;
          _cursor = pos2; 
          _testing = testing1;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          // Range
          $$ = _parse_Range();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            // !"]"
            final $1 = seq[0];
            // Range
            final $2 = seq[1];
            $$ = $2;    
          }
          break;  
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        if (!success && _cursor > _testing) {
          // Expected: "\\", "\\u", null
          _failure(_expect8);
        }
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      // "]"
      $$ = _matchChar(93, ']');
      if (!success) break;
      seq[2] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[3] = $$;
      $$ = seq;
      if (success) {    
        // "["
        final $1 = seq[0];
        // (!"]" Range)*
        final $2 = seq[1];
        // "]"
        final $3 = seq[2];
        // SPACING
        final $4 = seq[3];
        $$ = new CharacterClassExpression($2);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "["
      _failure(_expect9);
    }
    return $$;
  }
  
  dynamic _parse_DOT() {
    // TERMINAL
    // DOT <- "." SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = ".";  
      _tokenStart = _cursor;  
    }  
    // "." SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "."
      $$ = _matchChar(46, '.');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "."
      _failure(_expect10);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Definition() {
    // NONTERMINAL
    // Definition <- IDENTIFIER LEFTARROW Expression
    var $$;
    // IDENTIFIER LEFTARROW Expression
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // IDENTIFIER
      $$ = null;
      success = _ch >= 65 && _ch <= 122 && _lookahead[_ch + -9];
      // Lookahead (IDENTIFIER)
      if (success) $$ = _parse_IDENTIFIER();    
      if (!success) {    
        // Expected: "IDENTIFIER"    
        if (_cursor > _testing) _failure(_expect11);
        break;  
      }
      var seq = new List(3)..[0] = $$;
      // LEFTARROW
      $$ = null;
      success = _ch == 60; // '<'
      // Lookahead (LEFTARROW)
      if (success) $$ = _parse_LEFTARROW();
      if (!success) {
        // Expected: "<-"
        if (_cursor > _testing) _failure(_expect12);  
        break;  
      }
      seq[1] = $$;
      // Expression
      $$ = null;
      success = _ch >= 33 && _ch <= 122 && _lookahead[_ch + 82];
      // Lookahead (Expression)
      if (success) $$ = _parse_Expression();    
      if (!success) {    
        // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."    
        if (_cursor > _testing) _failure(_expect13);
        break;  
      }
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // IDENTIFIER
        final $1 = seq[0];
        // LEFTARROW
        final $2 = seq[1];
        // Expression
        final $3 = seq[2];
        $$ = new ProductionRule($1, $3);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER"
      _failure(_expect11);
    }
    return $$;
  }
  
  dynamic _parse_EOF() {
    // TERMINAL
    // EOF <- !.
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "EOF";  
      _tokenStart = _cursor;  
    }  
    // !.
    var ch0 = _ch, pos0 = _cursor, testing0 = _testing; 
    _testing = _inputLen + 1;
    // .
    $$ = _matchAny();
    _ch = ch0;
    _cursor = pos0; 
    _testing = testing0;
    $$ = null;
    success = !success;
    if (!success && _cursor > _testing) {
      // Expected: "EOF"
      _failure(_expect14);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_EOL() {
    // TERMINAL
    // EOL <- "\r\n" / [\n\r]
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "EOL";  
      _tokenStart = _cursor;  
    }  
    // "\r\n" / [\n\r]
    while (true) {
      // "\r\n"
      $$ = _matchString(_strings0, '\r\n');
      if (success) break;
      // [\n\r]
      $$ = _matchMapping(10, 13, _mapping1);
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "EOL"
      _failure(_expect4);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Expression() {
    // NONTERMINAL
    // Expression <- Sequence (SLASH Sequence)*
    var $$;
    // Sequence (SLASH Sequence)*
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // Sequence
      $$ = null;
      success = _ch >= 33 && _ch <= 122 && _lookahead[_ch + 82];
      // Lookahead (Sequence)
      if (success) $$ = _parse_Sequence();    
      if (!success) {    
        // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."    
        if (_cursor > _testing) _failure(_expect13);
        break;  
      }
      var seq = new List(2)..[0] = $$;
      // (SLASH Sequence)*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // SLASH Sequence
        var ch1 = _ch, pos1 = _cursor;
        while (true) {  
          // SLASH
          $$ = null;
          success = _ch == 47; // '/'
          // Lookahead (SLASH)
          if (success) $$ = _parse_SLASH();
          if (!success) {
            // Expected: "/"
            if (_cursor > _testing) _failure(_expect15);  
            break;  
          }
          var seq = new List(2)..[0] = $$;
          // Sequence
          $$ = null;
          success = _ch >= 33 && _ch <= 122 && _lookahead[_ch + 82];
          // Lookahead (Sequence)
          if (success) $$ = _parse_Sequence();    
          if (!success) {    
            // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."    
            if (_cursor > _testing) _failure(_expect13);
            break;  
          }
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            // SLASH
            final $1 = seq[0];
            // Sequence
            final $2 = seq[1];
            $$ = $2;    
          }
          break;  
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        if (!success && _cursor > _testing) {
          // Expected: "/"
          _failure(_expect15);
        }
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // Sequence
        final $1 = seq[0];
        // (SLASH Sequence)*
        final $2 = seq[1];
        $$ = new OrderedChoiceExpression(_flatten([$1, $2]));    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."
      _failure(_expect13);
    }
    return $$;
  }
  
  dynamic _parse_Globals() {
    // NONTERMINAL
    // Globals <- "%{" GlobalsBody* "}%" SPACING
    var $$;
    // "%{" GlobalsBody* "}%" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "%{"
      $$ = _matchString(_strings1, '%{');
      if (!success) break;
      var seq = new List(4)..[0] = $$;
      // GlobalsBody*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // GlobalsBody
        $$ = _parse_GlobalsBody();
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      // "}%"
      $$ = _matchString(_strings2, '}%');
      if (!success) break;
      seq[2] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[3] = $$;
      $$ = seq;
      if (success) {    
        // "%{"
        final $1 = seq[0];
        // GlobalsBody*
        final $2 = seq[1];
        // "}%"
        final $3 = seq[2];
        // SPACING
        final $4 = seq[3];
        $$ = _normalize(["{", $2, "}", $4]).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "%{"
      _failure(_expect16);
    }
    return $$;
  }
  
  dynamic _parse_GlobalsBody() {
    // NONTERMINAL
    // GlobalsBody <- !"}%" .
    var $$;
    // !"}%" .
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // !"}%"
      var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
      _testing = _inputLen + 1;
      // "}%"
      $$ = _matchString(_strings2, '}%');
      _ch = ch1;
      _cursor = pos1; 
      _testing = testing0;
      $$ = null;
      success = !success;
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // .
      $$ = _matchAny();
      if (!success) break;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // !"}%"
        final $1 = seq[0];
        // .
        final $2 = seq[1];
        $$ = $2;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: null
      _failure(_expect5);
    }
    return $$;
  }
  
  dynamic _parse_HEX_NUMBER() {
    // TERMINAL
    // HEX_NUMBER <- "\\u" [0-9A-Fa-f]+
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "\\u";  
      _tokenStart = _cursor;  
    }  
    // "\\u" [0-9A-Fa-f]+
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "\\u"
      $$ = _matchString(_strings3, '\\u');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // [0-9A-Fa-f]+
      var testing0;
      for (var first = true, reps; ;) {  
        // [0-9A-Fa-f]  
        $$ = _matchMapping(48, 102, _mapping2);  
        if (success) {
         if (first) {      
            first = false;
            reps = [$$];
            testing0 = _testing;                  
          } else {
            reps.add($$);
          }
          _testing = _cursor;   
        } else {
          success = !first;
          if (success) {      
            _testing = testing0;
            $$ = reps;      
          } else $$ = null;
          break;
        }  
      }
      if (!success) break;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "\\u"
        final $1 = seq[0];
        // [0-9A-Fa-f]+
        final $2 = seq[1];
        $$ = int.parse($2.join(), radix: 16);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "\\u"
      _failure(_expect7);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_IDENTIFIER() {
    // TERMINAL
    // IDENTIFIER <- IDENT_START IDENT_CONT* SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "IDENTIFIER";  
      _tokenStart = _cursor;  
    }  
    // IDENT_START IDENT_CONT* SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // IDENT_START
      $$ = null;
      success = _ch >= 65 && _ch <= 122 && _lookahead[_ch + -9];
      // Lookahead (IDENT_START)
      if (success) $$ = _parse_IDENT_START();    
      if (!success) {    
        // Expected: "IDENT_START"    
        if (_cursor > _testing) _failure(_expect17);
        break;  
      }
      var seq = new List(3)..[0] = $$;
      // IDENT_CONT*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // IDENT_CONT
        $$ = null;
        success = _ch >= 48 && _ch <= 122 && _lookahead[_ch + 246];
        // Lookahead (IDENT_CONT)
        if (success) $$ = _parse_IDENT_CONT();    
        if (!success) {    
          // Expected: "IDENT_CONT"    
          if (_cursor > _testing) _failure(_expect18);
        }
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // IDENT_START
        final $1 = seq[0];
        // IDENT_CONT*
        final $2 = seq[1];
        // SPACING
        final $3 = seq[2];
        $$ = _flatten([$1, $2]).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER"
      _failure(_expect11);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_IDENT_CONT() {
    // TERMINAL
    // IDENT_CONT <- IDENT_START / [0-9]
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "IDENT_CONT";  
      _tokenStart = _cursor;  
    }  
    // IDENT_START / [0-9]
    while (true) {
      // IDENT_START
      $$ = null;
      success = _ch >= 65 && _ch <= 122 && _lookahead[_ch + -9];
      // Lookahead (IDENT_START)
      if (success) $$ = _parse_IDENT_START();    
      if (!success) {    
        // Expected: "IDENT_START"    
        if (_cursor > _testing) _failure(_expect17);
      }
      if (success) break;
      // [0-9]
      $$ = _matchRange(48, 57);
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENT_CONT"
      _failure(_expect18);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_IDENT_START() {
    // TERMINAL
    // IDENT_START <- [A-Z_a-z]
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "IDENT_START";  
      _tokenStart = _cursor;  
    }  
    // [A-Z_a-z]
    $$ = _matchMapping(65, 122, _mapping3);
    if (!success && _cursor > _testing) {
      // Expected: "IDENT_START"
      _failure(_expect17);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_LEFTARROW() {
    // TERMINAL
    // LEFTARROW <- "<-" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "<-";  
      _tokenStart = _cursor;  
    }  
    // "<-" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "<-"
      $$ = _matchString(_strings4, '<-');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "<-"
      _failure(_expect12);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Literal() {
    // NONTERMINAL
    // Literal <- "\'" (!"\'" Char)* "\'" SPACING / "\"" (!"\"" Char)* "\"" SPACING
    var $$;
    // "\'" (!"\'" Char)* "\'" SPACING / "\"" (!"\"" Char)* "\"" SPACING
    while (true) {
      // "\'" (!"\'" Char)* "\'" SPACING
      var ch0 = _ch, pos0 = _cursor;
      while (true) {  
        // "\'"
        $$ = _matchChar(39, '\'');
        if (!success) break;
        var seq = new List(4)..[0] = $$;
        // (!"\'" Char)*
        var testing0 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          // !"\'" Char
          var ch1 = _ch, pos1 = _cursor;
          while (true) {  
            // !"\'"
            var ch2 = _ch, pos2 = _cursor, testing1 = _testing; 
            _testing = _inputLen + 1;
            // "\'"
            $$ = _matchChar(39, '\'');
            _ch = ch2;
            _cursor = pos2; 
            _testing = testing1;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            // Char
            $$ = _parse_Char();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              // !"\'"
              final $1 = seq[0];
              // Char
              final $2 = seq[1];
              $$ = $2;    
            }
            break;  
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          if (!success && _cursor > _testing) {
            // Expected: "\\", "\\u", null
            _failure(_expect8);
          }
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing0;
            $$ = reps;
            break; 
          }
        }
        if (!success) break;
        seq[1] = $$;
        // "\'"
        $$ = _matchChar(39, '\'');
        if (!success) break;
        seq[2] = $$;
        // SPACING
        $$ = null;
        success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
        // Lookahead (SPACING is optional)
        if (success) $$ = _parse_SPACING();
        else success = true;
        seq[3] = $$;
        $$ = seq;
        if (success) {    
          // "\'"
          final $1 = seq[0];
          // (!"\'" Char)*
          final $2 = seq[1];
          // "\'"
          final $3 = seq[2];
          // SPACING
          final $4 = seq[3];
          $$ = new LiteralExpression(new String.fromCharCodes($2));    
        }
        break;  
      }
      if (!success) {
        _ch = ch0;
        _cursor = pos0;
      }
      if (success) break;
      // "\"" (!"\"" Char)* "\"" SPACING
      var ch3 = _ch, pos3 = _cursor;
      while (true) {  
        // "\""
        $$ = _matchChar(34, '\"');
        if (!success) break;
        var seq = new List(4)..[0] = $$;
        // (!"\"" Char)*
        var testing2 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          // !"\"" Char
          var ch4 = _ch, pos4 = _cursor;
          while (true) {  
            // !"\""
            var ch5 = _ch, pos5 = _cursor, testing3 = _testing; 
            _testing = _inputLen + 1;
            // "\""
            $$ = _matchChar(34, '\"');
            _ch = ch5;
            _cursor = pos5; 
            _testing = testing3;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            // Char
            $$ = _parse_Char();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              // !"\""
              final $1 = seq[0];
              // Char
              final $2 = seq[1];
              $$ = $2;    
            }
            break;  
          }
          if (!success) {
            _ch = ch4;
            _cursor = pos4;
          }
          if (!success && _cursor > _testing) {
            // Expected: "\\", "\\u", null
            _failure(_expect8);
          }
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing2;
            $$ = reps;
            break; 
          }
        }
        if (!success) break;
        seq[1] = $$;
        // "\""
        $$ = _matchChar(34, '\"');
        if (!success) break;
        seq[2] = $$;
        // SPACING
        $$ = null;
        success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
        // Lookahead (SPACING is optional)
        if (success) $$ = _parse_SPACING();
        else success = true;
        seq[3] = $$;
        $$ = seq;
        if (success) {    
          // "\""
          final $1 = seq[0];
          // (!"\"" Char)*
          final $2 = seq[1];
          // "\""
          final $3 = seq[2];
          // SPACING
          final $4 = seq[3];
          $$ = new LiteralExpression(new String.fromCharCodes($2));    
        }
        break;  
      }
      if (!success) {
        _ch = ch3;
        _cursor = pos3;
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "\'", "\""
      _failure(_expect19);
    }
    return $$;
  }
  
  dynamic _parse_Members() {
    // NONTERMINAL
    // Members <- "{" ActionBody* "}" SPACING
    var $$;
    // "{" ActionBody* "}" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "{"
      $$ = _matchChar(123, '{');
      if (!success) break;
      var seq = new List(4)..[0] = $$;
      // ActionBody*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // ActionBody
        $$ = _parse_ActionBody();
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      // "}"
      $$ = _matchChar(125, '}');
      if (!success) break;
      seq[2] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[3] = $$;
      $$ = seq;
      if (success) {    
        // "{"
        final $1 = seq[0];
        // ActionBody*
        final $2 = seq[1];
        // "}"
        final $3 = seq[2];
        // SPACING
        final $4 = seq[3];
        $$ = _normalize([$1, $2, $3, $4]).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "{"
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_NOT() {
    // TERMINAL
    // NOT <- "!" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "!";  
      _tokenStart = _cursor;  
    }  
    // "!" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "!"
      $$ = _matchChar(33, '!');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "!"
        final $1 = seq[0];
        // SPACING
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "!"
      _failure(_expect20);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_OPEN() {
    // TERMINAL
    // OPEN <- "(" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "(";  
      _tokenStart = _cursor;  
    }  
    // "(" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "("
      $$ = _matchChar(40, '(');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "("
      _failure(_expect21);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_PLUS() {
    // TERMINAL
    // PLUS <- "+" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "+";  
      _tokenStart = _cursor;  
    }  
    // "+" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "+"
      $$ = _matchChar(43, '+');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "+"
        final $1 = seq[0];
        // SPACING
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "+"
      _failure(_expect22);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Prefix() {
    // NONTERMINAL
    // Prefix <- (AND / NOT)? Suffix Action?
    var $$;
    // (AND / NOT)? Suffix Action?
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // (AND / NOT)?
      var testing0 = _testing;
      _testing = _cursor;
      // AND / NOT
      while (true) {
        // AND
        $$ = null;
        success = _ch == 38; // '&'
        // Lookahead (AND)
        if (success) $$ = _parse_AND();
        if (!success) {
          // Expected: "&"
          if (_cursor > _testing) _failure(_expect0);  
        }
        if (success) break;
        // NOT
        $$ = null;
        success = _ch == 33; // '!'
        // Lookahead (NOT)
        if (success) $$ = _parse_NOT();
        if (!success) {
          // Expected: "!"
          if (_cursor > _testing) _failure(_expect20);  
        }
        break;
      }
      if (!success && _cursor > _testing) {
        // Expected: "&", "!"
        _failure(_expect23);
      }
      success = true; 
      _testing = testing0;
      if (!success) break;
      var seq = new List(3)..[0] = $$;
      // Suffix
      $$ = null;
      success = _ch >= 34 && _ch <= 122 && _lookahead[_ch + 171];
      // Lookahead (Suffix)
      if (success) $$ = _parse_Suffix();    
      if (!success) {    
        // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."    
        if (_cursor > _testing) _failure(_expect13);
        break;  
      }
      seq[1] = $$;
      // Action?
      var testing1 = _testing;
      _testing = _cursor;
      // Action
      $$ = null;
      success = _ch == 123; // '{'
      // Lookahead (Action)
      if (success) $$ = _parse_Action();
      if (!success) {
        // Expected: "{"
        if (_cursor > _testing) _failure(_expect1);  
      }
      success = true; 
      _testing = testing1;
      if (!success) break;
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // (AND / NOT)?
        final $1 = seq[0];
        // Suffix
        final $2 = seq[1];
        // Action?
        final $3 = seq[2];
        $$ = _prefix($1, $2, $3);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."
      _failure(_expect13);
    }
    return $$;
  }
  
  dynamic _parse_Primary() {
    // NONTERMINAL
    // Primary <- IDENTIFIER !LEFTARROW / OPEN Expression CLOSE / Literal / Class / DOT
    var $$;
    // IDENTIFIER !LEFTARROW / OPEN Expression CLOSE / Literal / Class / DOT
    while (true) {
      // IDENTIFIER !LEFTARROW
      var ch0 = _ch, pos0 = _cursor;
      while (true) {  
        // IDENTIFIER
        $$ = null;
        success = _ch >= 65 && _ch <= 122 && _lookahead[_ch + -9];
        // Lookahead (IDENTIFIER)
        if (success) $$ = _parse_IDENTIFIER();    
        if (!success) {    
          // Expected: "IDENTIFIER"    
          if (_cursor > _testing) _failure(_expect11);
          break;  
        }
        var seq = new List(2)..[0] = $$;
        // !LEFTARROW
        var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
        _testing = _inputLen + 1;
        // LEFTARROW
        $$ = null;
        success = _ch == 60; // '<'
        // Lookahead (LEFTARROW)
        if (success) $$ = _parse_LEFTARROW();
        if (!success) {
          // Expected: "<-"
          if (_cursor > _testing) _failure(_expect12);  
        }
        _ch = ch1;
        _cursor = pos1; 
        _testing = testing0;
        $$ = null;
        success = !success;
        if (!success) break;
        seq[1] = $$;
        $$ = seq;
        if (success) {    
          // IDENTIFIER
          final $1 = seq[0];
          // !LEFTARROW
          final $2 = seq[1];
          $$ = new RuleExpression($1);    
        }
        break;  
      }
      if (!success) {
        _ch = ch0;
        _cursor = pos0;
      }
      if (success) break;
      // OPEN Expression CLOSE
      var ch2 = _ch, pos2 = _cursor;
      while (true) {  
        // OPEN
        $$ = null;
        success = _ch == 40; // '('
        // Lookahead (OPEN)
        if (success) $$ = _parse_OPEN();
        if (!success) {
          // Expected: "("
          if (_cursor > _testing) _failure(_expect21);  
          break;  
        }
        var seq = new List(3)..[0] = $$;
        // Expression
        $$ = null;
        success = _ch >= 33 && _ch <= 122 && _lookahead[_ch + 82];
        // Lookahead (Expression)
        if (success) $$ = _parse_Expression();    
        if (!success) {    
          // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."    
          if (_cursor > _testing) _failure(_expect13);
          break;  
        }
        seq[1] = $$;
        // CLOSE
        $$ = null;
        success = _ch == 41; // ')'
        // Lookahead (CLOSE)
        if (success) $$ = _parse_CLOSE();
        if (!success) {
          // Expected: ")"
          if (_cursor > _testing) _failure(_expect3);  
          break;  
        }
        seq[2] = $$;
        $$ = seq;
        if (success) {    
          // OPEN
          final $1 = seq[0];
          // Expression
          final $2 = seq[1];
          // CLOSE
          final $3 = seq[2];
          $$ = $2;    
        }
        break;  
      }
      if (!success) {
        _ch = ch2;
        _cursor = pos2;
      }
      if (success) break;
      // Literal
      $$ = null;
      success = _ch >= 34 && _ch <= 39 && _lookahead[_ch + 47];
      // Lookahead (Literal)
      if (success) $$ = _parse_Literal();    
      if (!success) {    
        // Expected: "\'", "\""    
        if (_cursor > _testing) _failure(_expect19);
      }
      if (success) break;
      // Class
      $$ = null;
      success = _ch == 91; // '['
      // Lookahead (Class)
      if (success) $$ = _parse_Class();
      if (!success) {
        // Expected: "["
        if (_cursor > _testing) _failure(_expect9);  
      }
      if (success) break;
      // DOT
      $$ = null;
      success = _ch == 46; // '.'
      // Lookahead (DOT)
      if (success) $$ = _parse_DOT();
      if (!success) {
        // Expected: "."
        if (_cursor > _testing) _failure(_expect10);  
      }
      if (success) {    
        // DOT
        final $1 = $$;
        $$ = new AnyCharacterExpression();    
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."
      _failure(_expect13);
    }
    return $$;
  }
  
  dynamic _parse_QUESTION() {
    // TERMINAL
    // QUESTION <- "?" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "?";  
      _tokenStart = _cursor;  
    }  
    // "?" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "?"
      $$ = _matchChar(63, '?');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "?"
        final $1 = seq[0];
        // SPACING
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "?"
      _failure(_expect24);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Range() {
    // NONTERMINAL
    // Range <- Char "-" Char / Char
    var $$;
    // Char "-" Char / Char
    while (true) {
      // Char "-" Char
      var ch0 = _ch, pos0 = _cursor;
      while (true) {  
        // Char
        $$ = _parse_Char();
        if (!success) break;
        var seq = new List(3)..[0] = $$;
        // "-"
        $$ = _matchChar(45, '-');
        if (!success) break;
        seq[1] = $$;
        // Char
        $$ = _parse_Char();
        if (!success) break;
        seq[2] = $$;
        $$ = seq;
        if (success) {    
          // Char
          final $1 = seq[0];
          // "-"
          final $2 = seq[1];
          // Char
          final $3 = seq[2];
          $$ = [$1, $3];    
        }
        break;  
      }
      if (!success) {
        _ch = ch0;
        _cursor = pos0;
      }
      if (success) break;
      // Char
      $$ = _parse_Char();
      if (success) {    
        // Char
        final $1 = $$;
        $$ = [$1, $1];    
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "\\", "\\u", null
      _failure(_expect8);
    }
    return $$;
  }
  
  dynamic _parse_SLASH() {
    // TERMINAL
    // SLASH <- "/" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "/";  
      _tokenStart = _cursor;  
    }  
    // "/" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "/"
      $$ = _matchChar(47, '/');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "/"
      _failure(_expect15);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_SPACE() {
    // TERMINAL
    // SPACE <- [\t ] / EOL
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "SPACE";  
      _tokenStart = _cursor;  
    }  
    // [\t ] / EOL
    while (true) {
      // [\t ]
      $$ = _matchMapping(9, 32, _mapping4);
      if (success) break;
      // EOL
      $$ = null;
      success = _ch >= 10 && _ch <= 13 && _lookahead[_ch + -9];
      // Lookahead (EOL)
      if (success) $$ = _parse_EOL();    
      if (!success) {    
        // Expected: "EOL"    
        if (_cursor > _testing) _failure(_expect4);
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "SPACE"
      _failure(_expect25);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_SPACING() {
    // TERMINAL
    // SPACING <- (SPACE / COMMENT)*
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "SPACING";  
      _tokenStart = _cursor;  
    }  
    // (SPACE / COMMENT)*
    var testing0 = _testing; 
    for (var reps = []; ; ) {
      _testing = _cursor;
      // SPACE / COMMENT
      while (true) {
        // SPACE
        $$ = null;
        success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
        // Lookahead (SPACE)
        if (success) $$ = _parse_SPACE();    
        if (!success) {    
          // Expected: "SPACE"    
          if (_cursor > _testing) _failure(_expect25);
        }
        if (success) break;
        // COMMENT
        $$ = null;
        success = _ch == 35; // '#'
        // Lookahead (COMMENT)
        if (success) $$ = _parse_COMMENT();
        if (!success) {
          // Expected: "#"
          if (_cursor > _testing) _failure(_expect6);  
        }
        break;
      }
      if (!success && _cursor > _testing) {
        // Expected: "SPACE", "#"
        _failure(_expect26);
      }
      if (success) {  
        reps.add($$);
      } else {
        success = true;
        _testing = testing0;
        $$ = reps;
        break; 
      }
    }
    if (!success && _cursor > _testing) {
      // Expected: "SPACING"
      _failure(_expect27);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_STAR() {
    // TERMINAL
    // STAR <- "*" SPACING
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "*";  
      _tokenStart = _cursor;  
    }  
    // "*" SPACING
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "*"
      $$ = _matchChar(42, '*');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "*"
        final $1 = seq[0];
        // SPACING
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "*"
      _failure(_expect28);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_Sequence() {
    // NONTERMINAL
    // Sequence <- Prefix+
    var $$;
    // Prefix+
    var testing0;
    for (var first = true, reps; ;) {  
      // Prefix  
      $$ = null;  
      success = _ch >= 33 && _ch <= 122 && _lookahead[_ch + 82];  
      // Lookahead (Prefix)  
      if (success) $$ = _parse_Prefix();      
      if (!success) {      
        // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."      
        if (_cursor > _testing) _failure(_expect13);  
      }  
      if (success) {
       if (first) {      
          first = false;
          reps = [$$];
          testing0 = _testing;                  
        } else {
          reps.add($$);
        }
        _testing = _cursor;   
      } else {
        success = !first;
        if (success) {      
          _testing = testing0;
          $$ = reps;      
        } else $$ = null;
        break;
      }  
    }
    if (success) {    
      // Prefix+
      final $1 = $$;
      $$ = new SequenceExpression($1);    
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."
      _failure(_expect13);
    }
    return $$;
  }
  
  dynamic _parse_Suffix() {
    // NONTERMINAL
    // Suffix <- Primary (QUESTION / STAR / PLUS)?
    var $$;
    // Primary (QUESTION / STAR / PLUS)?
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // Primary
      $$ = null;
      success = _ch >= 34 && _ch <= 122 && _lookahead[_ch + 171];
      // Lookahead (Primary)
      if (success) $$ = _parse_Primary();    
      if (!success) {    
        // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."    
        if (_cursor > _testing) _failure(_expect13);
        break;  
      }
      var seq = new List(2)..[0] = $$;
      // (QUESTION / STAR / PLUS)?
      var testing0 = _testing;
      _testing = _cursor;
      // QUESTION / STAR / PLUS
      while (true) {
        // QUESTION
        $$ = null;
        success = _ch == 63; // '?'
        // Lookahead (QUESTION)
        if (success) $$ = _parse_QUESTION();
        if (!success) {
          // Expected: "?"
          if (_cursor > _testing) _failure(_expect24);  
        }
        if (success) break;
        // STAR
        $$ = null;
        success = _ch == 42; // '*'
        // Lookahead (STAR)
        if (success) $$ = _parse_STAR();
        if (!success) {
          // Expected: "*"
          if (_cursor > _testing) _failure(_expect28);  
        }
        if (success) break;
        // PLUS
        $$ = null;
        success = _ch == 43; // '+'
        // Lookahead (PLUS)
        if (success) $$ = _parse_PLUS();
        if (!success) {
          // Expected: "+"
          if (_cursor > _testing) _failure(_expect22);  
        }
        break;
      }
      if (!success && _cursor > _testing) {
        // Expected: "?", "*", "+"
        _failure(_expect29);
      }
      success = true; 
      _testing = testing0;
      if (!success) break;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // Primary
        final $1 = seq[0];
        // (QUESTION / STAR / PLUS)?
        final $2 = seq[1];
        $$ = _suffix($2, $1);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER", "(", "\'", "\"", "[", "."
      _failure(_expect13);
    }
    return $$;
  }
  
  dynamic parse_Grammar() {
    // NONTERMINAL
    // Grammar <- SPACING? Globals? Members? Definition+ EOF
    var $$;
    // SPACING? Globals? Members? Definition+ EOF
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // SPACING?
      var testing0 = _testing;
      _testing = _cursor;
      // SPACING
      $$ = null;
      success = _ch >= 9 && _ch <= 35 && _lookahead[_ch + -9];
      // Lookahead (SPACING is optional)
      if (success) $$ = _parse_SPACING();
      else success = true;
      success = true; 
      _testing = testing0;
      if (!success) break;
      var seq = new List(5)..[0] = $$;
      // Globals?
      var testing1 = _testing;
      _testing = _cursor;
      // Globals
      $$ = null;
      success = _ch == 37; // '%'
      // Lookahead (Globals)
      if (success) $$ = _parse_Globals();
      if (!success) {
        // Expected: "%{"
        if (_cursor > _testing) _failure(_expect16);  
      }
      success = true; 
      _testing = testing1;
      if (!success) break;
      seq[1] = $$;
      // Members?
      var testing2 = _testing;
      _testing = _cursor;
      // Members
      $$ = null;
      success = _ch == 123; // '{'
      // Lookahead (Members)
      if (success) $$ = _parse_Members();
      if (!success) {
        // Expected: "{"
        if (_cursor > _testing) _failure(_expect1);  
      }
      success = true; 
      _testing = testing2;
      if (!success) break;
      seq[2] = $$;
      // Definition+
      var testing3;
      for (var first = true, reps; ;) {  
        // Definition  
        $$ = null;  
        success = _ch >= 65 && _ch <= 122 && _lookahead[_ch + -9];  
        // Lookahead (Definition)  
        if (success) $$ = _parse_Definition();      
        if (!success) {      
          // Expected: "IDENTIFIER"      
          if (_cursor > _testing) _failure(_expect11);  
        }  
        if (success) {
         if (first) {      
            first = false;
            reps = [$$];
            testing3 = _testing;                  
          } else {
            reps.add($$);
          }
          _testing = _cursor;   
        } else {
          success = !first;
          if (success) {      
            _testing = testing3;
            $$ = reps;      
          } else $$ = null;
          break;
        }  
      }
      if (!success) break;
      seq[3] = $$;
      // EOF
      $$ = _parse_EOF();
      if (!success) break;
      seq[4] = $$;
      $$ = seq;
      if (success) {    
        // SPACING?
        final $1 = seq[0];
        // Globals?
        final $2 = seq[1];
        // Members?
        final $3 = seq[2];
        // Definition+
        final $4 = seq[3];
        // EOF
        final $5 = seq[4];
        $$ = new Grammar($4, $2, $3);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "IDENTIFIER"
      _failure(_expect11);
    }
    return $$;
  }
  
  void _addToCache(dynamic result, int start, int id) {  
    var cached = _cache[start];
    if (cached == null) {
      _cacheRule[start] = id;
      _cache[start] = [result, _cursor, success];
    } else {    
      var slot = start >> 5;
      var r1 = (slot << 5) & 0x3fffffff;    
      var mask = 1 << (start - r1);    
      if ((_cacheState[slot] & mask) == 0) {
        _cacheState[slot] |= mask;   
        cached = [new List.filled(3, 0), new Map<int, List>()];
        _cache[start] = cached;                                      
      }
      slot = id >> 5;
      r1 = (slot << 5) & 0x3fffffff;    
      mask = 1 << (id - r1);    
      cached[0][slot] |= mask;
      cached[1][id] = [result, _cursor, success];      
    }
    if (_cachePos < start) {
      _cachePos = start;
    }    
  }
  
  void _calculatePos(int pos) {
    if (pos == null || pos < 0 || pos > _inputLen) {
      return;
    }
    _line = 1;
    _column = 1;
    for (var i = 0; i < _inputLen && i < pos; i++) {
      var c = _runes[i];
      if (c == 13) {
        _line++;
        _column = 1;
        if (i + 1 < _inputLen && _runes[i + 1] == 10) {
          i++;
        }
      } else if (c == 10) {
        _line++;
        _column = 1;
      } else {
        _column++;
      }
    }
  }
  
  Iterable _compact(Iterable iterable) {  
    if (iterable is List) {
      var hasNull = false;
      var length = iterable.length;
      for (var i = 0; i < length; i++) {
        if (iterable[i] == null) {
          hasNull = true;
          break;
        }
      }
      if (!hasNull) {
        return iterable;
      }
      var result = [];
      for (var i = 0; i < length; i++) {
        var element = iterable[i];
        if (element != null) {
          result.add(element);
        }
      }
      return result;
    }   
    var result = [];
    for (var element in iterable) {   
      if (element != null) {
        result.add(element);
      }
    }
    return result;  
  }
  
  void _failure([List<String> expected]) {  
    if (_failurePos > _cursor) {
      return;
    }
    if (_cursor > _failurePos) {    
      _expected = [];
     _failurePos = _cursor;
    }
    if (_token != null) {
      _expected.add(_token);
    } else if (expected == null) {
      _expected.add(null);
    } else {
      _expected.addAll(expected);
    }   
  }
  
  List _flatten(dynamic value) {
    if (value is List) {
      var result = [];
      var length = value.length;
      for (var i = 0; i < length; i++) {
        var element = value[i];
        if (element is Iterable) {
          result.addAll(_flatten(element));
        } else {
          result.add(element);
        }
      }
      return result;
    } else if (value is Iterable) {
      var result = [];
      for (var element in value) {
        if (element is! List) {
          result.add(element);
        } else {
          result.addAll(_flatten(element));
        }
      }
    }
    return [value];
  }
  
  dynamic _getFromCache(int id) {  
    var result = _cache[_cursor];
    if (result == null) {
      return null;
    }    
    var slot = _cursor >> 5;
    var r1 = (slot << 5) & 0x3fffffff;  
    var mask = 1 << (_cursor - r1);
    if ((_cacheState[slot] & mask) == 0) {
      if (_cacheRule[_cursor] == id) {      
        _cursor = result[1];
        success = result[2];      
        if (_cursor < _inputLen) {
          _ch = _runes[_cursor];
        } else {
          _ch = EOF;
        }      
        return result;
      } else {
        return null;
      }    
    }
    slot = id >> 5;
    r1 = (slot << 5) & 0x3fffffff;  
    mask = 1 << (id - r1);
    if ((result[0][slot] & mask) == 0) {
      return null;
    }
    var data = result[1][id];  
    _cursor = data[1];
    success = data[2];
    if (_cursor < _inputLen) {
      _ch = _runes[_cursor];
    } else {
      _ch = EOF;
    }   
    return data;  
  }
  
  String _matchAny() {
    success = _cursor < _inputLen;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }    
      if (++_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }    
      return result;
    }    
    return null;  
  }
  
  String _matchChar(int ch, String string) {
    success = _ch == ch;
    if (success) {
      var result = string;  
      if (++_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }    
      return result;
    }  
    return null;  
  }
  
  String _matchMapping(int start, int end, List<bool> mapping) {
    success = _ch >= start && _ch <= end;
    if (success) {    
      if(mapping[_ch - start]) {
        String result;
        if (_ch < 128) {
          result = _ascii[_ch];  
        } else {
          result = new String.fromCharCode(_ch);
        }     
        if (++_cursor < _inputLen) {
          _ch = _runes[_cursor];
        } else {
          _ch = EOF;
        }      
        return result;
      }
      success = false;
    }  
    return null;  
  }
  
  String _matchRange(int start, int end) {
    success = _ch >= start && _ch <= end;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }        
      if (++_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }  
      return result;
    }  
    return null;  
  }
  
  String _matchRanges(List<int> ranges) {
    var length = ranges.length;
    for (var i = 0; i < length; i += 2) {
      if (_ch <= ranges[i + 1]) {
        if (_ch >= ranges[i]) {
          String result;
          if (_ch < 128) {
            result = _ascii[_ch];  
          } else {
            result = new String.fromCharCode(_ch);
          }          
          if (++_cursor < _inputLen) {
            _ch = _runes[_cursor];
          } else {
             _ch = EOF;
          }
          success = true;    
          return result;
        }      
      } else break;  
    }
    success = false;  
    return null;  
  }
  
  String _matchString(List<int> runes, String string) {
    var length = runes.length;  
    success = true;  
    if (_cursor + length < _inputLen) {
      for (var i = 0; i < length; i++) {
        if (runes[i] != _runes[_cursor + i]) {
          success = false;
          break;
        }
      }
    } else {
      success = false;
    }  
    if (success) {
      _cursor += length;      
      if (_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }    
      return string;      
    }  
    return null; 
  }
  
  void _nextChar([int count = 1]) {  
    success = true;
    _cursor += count; 
    if (_cursor < _inputLen) {
      _ch = _runes[_cursor];
    } else {
      _ch = EOF;
    }    
  }
  
  bool _testChar(int c, int flag) {
    if (c < 0 || c > 127) {
      return false;
    }    
    int slot = (c & 0xff) >> 6;  
    int mask = 1 << c - ((slot << 6) & 0x3fffffff);  
    if ((flag & mask) != 0) {    
      return true;
    }
    return false;           
  }
  
  bool _testInput(int flag) {
    if (_cursor >= _inputLen) {
      return false;
    }
    var c = _runes[_cursor];
    if (c < 0 || c > 127) {
      return false;
    }    
    int slot = (c & 0xff) >> 6;  
    int mask = 1 << c - ((slot << 6) & 0x3fffffff);  
    if ((flag & mask) != 0) {    
      return true;
    }
    return false;           
  }
  
  int _toRune(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      throw new StateError("An empty string contains no elements.");
    }
  
    var start = string.codeUnitAt(0);
    if (length == 1) {
      return start;
    }
  
    if ((start & 0xFC00) == 0xD800) {
      var end = string.codeUnitAt(1);
      if ((end & 0xFC00) == 0xDC00) {
        return (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
      }
    }
  
    return start;
  }
  
  List<int> _toRunes(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      return const <int>[];
    }
  
    var runes = <int>[];
    runes.length = length;
    var i = 0;
    var pos = 0;
    for ( ; i < length; pos++) {
      var start = string.codeUnitAt(i);
      i++;
      if ((start & 0xFC00) == 0xD800 && i < length) {
        var end = string.codeUnitAt(i);
        if ((end & 0xFC00) == 0xDC00) {
          runes[pos] = (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
          i++;
        } else {
          runes[pos] = start;
        }
      } else {
        runes[pos] = start;
      }
    }
  
    runes.length = pos;
    return runes;
  }
  
  static List<bool> _unmap(List<int> mapping) {
    var length = mapping.length;
    var result = new List<bool>(length * 31);
    var offset = 0;
    for (var i = 0; i < length; i++) {
      var v = mapping[i];
      for (var j = 0; j < 31; j++) {
        result[offset++] = v & (1 << j) == 0 ? false : true;
      }
    }
    return result;
  }
  
  List<String> get expected {
    var set = new Set<String>();  
    set.addAll(_expected);
    if (set.contains(null)) {
      set.clear();
    }  
    var result = set.toList();
    result.sort(); 
    return result;        
  }
  
  void reset(int pos) {
    if (pos == null) {
      throw new ArgumentError('pos: $pos');
    }
    if (pos < 0 || pos > _inputLen) {
      throw new RangeError('pos');
    }      
    _cursor = pos;
    _cache = new List(_inputLen + 1);
    _cachePos = -1;
    _cacheRule = new List(_inputLen + 1);
    _cacheState = new List.filled(((_inputLen + 1) >> 5) + 1, 0);
    _ch = EOF;  
    _column = -1; 
    _expected = [];
    _failurePos = -1;    
    _line = -1;
    success = true;      
    _testing = -1;
    _token = null;
    _tokenLevel = 0;
    _tokenStart = null;
    if (_cursor < _inputLen) {
      _ch = _runes[_cursor];
    }    
  }
  
  String get unexpected {
    if (_failurePos < 0 || _failurePos >= _inputLen) {
      return '';    
    }
    return new String.fromCharCode(_runes[_failurePos]);  
  }
  
  List _normalize(Iterable sequence) => _flatten(_compact(sequence));
}

