// This code was generated by a tool.
// Processing tool available at https://github.com/mezoni/peg

library json_parser;

class _KeyValuePair<K, V> {
  final K key;
  final V value;
  const _KeyValuePair(this.key, this.value);
  String toString() => "$key : $value";
}

String _hex2str(String hex) {
  return new String.fromCharCode(int.parse(hex, radix: 16));
}

// "\\/bfnrt
String _escape(String string) {
  switch (string) {
    case "\"":
      return "\u0022";
    case "\\":
      return "\u005c";
    case "/":
      return "\u002f";    
    case "r":
      return "\u000d";
    case "n":
      return "\u000a";  
    case "t":
      return "\u0009";
    case "b":
      return "\u0008";
    case "f":
      return "\u000c";      
  }
  return string;
}

num _parseNumber(minus, integer, frac, exp) {
  var sign = minus == null ? 1 : -1;  
  if (frac != null || exp != null) {
    frac = frac == null ? "" : frac;
    exp = exp == null ? "" : exp;
    return double.parse("$integer$frac$exp") * sign;
  } else {
    return int.parse(integer) * sign;
  }
}
class JsonParser {
  static const int EOF = -1;
  static final List<String> _ascii = new List<String>.generate(128, (c) => new String.fromCharCode(c));
  static final List<bool> _lookahead = _unmap([0x800013, 0x0, 0x100000, 0x600000, 0x7fe4, 0x10020000, 0x1ffc0820, 0x7e0, 0xfc0]);
  // '\"', '/', '\\', 'b', 'f', 'n', 'r', 't'
  static final List<bool> _mapping0 = _unmap([0x2001, 0x8000000, 0x144044]);
  // '\t', '\n', '\r', ' '
  static final List<bool> _mapping1 = _unmap([0x800013]);
  // "false"
  static final List<int> _strings0 = <int>[102, 97, 108, 115, 101];
  // "null"
  static final List<int> _strings1 = <int>[110, 117, 108, 108];
  // "true"
  static final List<int> _strings2 = <int>[116, 114, 117, 101];
  static final List<String> _expect0 = <String>["["];
  static final List<String> _expect1 = <String>["{"];
  static final List<String> _expect2 = <String>["\\"];
  static final List<String> _expect3 = <String>["HEXDIG"];
  static final List<String> _expect4 = <String>["CHAR"];
  static final List<String> _expect5 = <String>["."];
  static final List<String> _expect6 = <String>["DIGIT"];
  static final List<String> _expect7 = <String>["E", "e"];
  static final List<String> _expect8 = <String>["E"];
  static final List<String> _expect9 = <String>["]"];
  static final List<String> _expect10 = <String>["}"];
  static final List<String> _expect11 = <String>["EOF"];
  static final List<String> _expect12 = <String>["-"];
  static final List<String> _expect13 = <String>["+"];
  static final List<String> _expect14 = <String>["+", "-"];
  static final List<String> _expect15 = <String>["EXP"];
  static final List<String> _expect16 = <String>["false"];
  static final List<String> _expect17 = <String>["INT"];
  static final List<String> _expect18 = <String>[":"];
  static final List<String> _expect19 = <String>["null"];
  static final List<String> _expect20 = <String>["NUMBER"];
  static final List<String> _expect21 = <String>["\""];
  static final List<String> _expect22 = <String>["true"];
  static final List<String> _expect23 = <String>["UNESCAPED"];
  static final List<String> _expect24 = <String>[","];
  static final List<String> _expect25 = <String>["WS"];
  static final List<String> _expect26 = <String>["\"", "NUMBER", "[", "false", "null", "true", "{"];
  static final List<String> _expect27 = <String>["[", "{"];
  List _cache;
  int _cachePos;
  List<int> _cacheRule;
  List<int> _cacheState;
  int _ch;
  int _column;
  int _cursor;
  List<String> _expected;
  int _failurePos;
  int _inputLen;
  int _line;
  List<int> _runes;
  bool success;
  int _testing;
  String _token;
  int _tokenLevel;
  int _tokenStart;
  
  JsonParser(String text) {
    if (text == null) {
      throw new ArgumentError('text: $text');
    }    
    _runes = _toRunes(text);
    _inputLen = _runes.length;
    if (_inputLen >= 0x3fffffe8 / 32) {
      throw new StateError('File size to big: $_inputLen');
    }  
    reset(0);    
  }
  
  int get column { 
    if (_column == -1) { 
      _calculatePos(_failurePos); 
    } 
    return _column;       
  } 
   
  int get line { 
    if (_line == -1) { 
      _calculatePos(_failurePos); 
    } 
    return _line;       
  } 
   
  dynamic _parse_BEGIN_ARRAY() {
    // TERMINAL
    // BEGIN_ARRAY <- "[" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "[";  
      _tokenStart = _cursor;  
    }  
    // "[" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "["
      $$ = _matchChar(91, '[');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "["
      _failure(_expect0);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_BEGIN_OBJECT() {
    // TERMINAL
    // BEGIN_OBJECT <- "{" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "{";  
      _tokenStart = _cursor;  
    }  
    // "{" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "{"
      $$ = _matchChar(123, '{');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "{"
      _failure(_expect1);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_CHAR() {
    // TERMINAL
    // CHAR <- UNESCAPED / ESCAPE ["/\bfnrt] / ESCAPE "u" HEXDIG HEXDIG HEXDIG HEXDIG
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "CHAR";  
      _tokenStart = _cursor;  
    }  
    // UNESCAPED / ESCAPE ["/\bfnrt] / ESCAPE "u" HEXDIG HEXDIG HEXDIG HEXDIG
    while (true) {
      // UNESCAPED
      $$ = _parse_UNESCAPED();
      if (success) break;
      // ESCAPE ["/\bfnrt]
      var ch0 = _ch, pos0 = _cursor;
      while (true) {  
        // ESCAPE
        $$ = null;
        success = _ch == 92; // '\'
        // Lookahead (ESCAPE)
        if (success) $$ = _parse_ESCAPE();
        if (!success) {
          // Expected: "\\"
          if (_cursor > _testing) _failure(_expect2);  
          break;  
        }
        var seq = new List(2)..[0] = $$;
        // ["/\bfnrt]
        $$ = _matchMapping(34, 116, _mapping0);
        if (!success) break;
        seq[1] = $$;
        $$ = seq;
        if (success) {    
          // ESCAPE
          final $1 = seq[0];
          // ["/\bfnrt]
          final $2 = seq[1];
          $$ = _escape($2);    
        }
        break;  
      }
      if (!success) {
        _ch = ch0;
        _cursor = pos0;
      }
      if (success) break;
      // ESCAPE "u" HEXDIG HEXDIG HEXDIG HEXDIG
      var ch1 = _ch, pos1 = _cursor;
      while (true) {  
        // ESCAPE
        $$ = null;
        success = _ch == 92; // '\'
        // Lookahead (ESCAPE)
        if (success) $$ = _parse_ESCAPE();
        if (!success) {
          // Expected: "\\"
          if (_cursor > _testing) _failure(_expect2);  
          break;  
        }
        var seq = new List(6)..[0] = $$;
        // "u"
        $$ = _matchChar(117, 'u');
        if (!success) break;
        seq[1] = $$;
        // HEXDIG
        $$ = null;
        success = _ch >= 48 && _ch <= 102 && _lookahead[_ch + 157];
        // Lookahead (HEXDIG)
        if (success) $$ = _parse_HEXDIG();    
        if (!success) {    
          // Expected: "HEXDIG"    
          if (_cursor > _testing) _failure(_expect3);
          break;  
        }
        seq[2] = $$;
        // HEXDIG
        $$ = null;
        success = _ch >= 48 && _ch <= 102 && _lookahead[_ch + 157];
        // Lookahead (HEXDIG)
        if (success) $$ = _parse_HEXDIG();    
        if (!success) {    
          // Expected: "HEXDIG"    
          if (_cursor > _testing) _failure(_expect3);
          break;  
        }
        seq[3] = $$;
        // HEXDIG
        $$ = null;
        success = _ch >= 48 && _ch <= 102 && _lookahead[_ch + 157];
        // Lookahead (HEXDIG)
        if (success) $$ = _parse_HEXDIG();    
        if (!success) {    
          // Expected: "HEXDIG"    
          if (_cursor > _testing) _failure(_expect3);
          break;  
        }
        seq[4] = $$;
        // HEXDIG
        $$ = null;
        success = _ch >= 48 && _ch <= 102 && _lookahead[_ch + 157];
        // Lookahead (HEXDIG)
        if (success) $$ = _parse_HEXDIG();    
        if (!success) {    
          // Expected: "HEXDIG"    
          if (_cursor > _testing) _failure(_expect3);
          break;  
        }
        seq[5] = $$;
        $$ = seq;
        if (success) {    
          // ESCAPE
          final $1 = seq[0];
          // "u"
          final $2 = seq[1];
          // HEXDIG
          final $3 = seq[2];
          // HEXDIG
          final $4 = seq[3];
          // HEXDIG
          final $5 = seq[4];
          // HEXDIG
          final $6 = seq[5];
          $$ = _hex2str([$3, $4, $5, $6].join());    
        }
        break;  
      }
      if (!success) {
        _ch = ch1;
        _cursor = pos1;
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "CHAR"
      _failure(_expect4);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_DECIMAL_POINT() {
    // TERMINAL
    // DECIMAL_POINT <- "." WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = ".";  
      _tokenStart = _cursor;  
    }  
    // "." WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "."
      $$ = _matchChar(46, '.');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "."
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "."
      _failure(_expect5);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_DIGIT() {
    // TERMINAL
    // DIGIT <- [0-9]
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "DIGIT";  
      _tokenStart = _cursor;  
    }  
    // [0-9]
    $$ = _matchRange(48, 57);
    if (!success && _cursor > _testing) {
      // Expected: "DIGIT"
      _failure(_expect6);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_E() {
    // TERMINAL
    // E <- ("e" / "E") WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "E";  
      _tokenStart = _cursor;  
    }  
    // ("e" / "E") WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "e" / "E"
      while (true) {
        // "e"
        $$ = _matchChar(101, 'e');
        if (success) break;
        // "E"
        $$ = _matchChar(69, 'E');
        break;
      }
      if (!success && _cursor > _testing) {
        // Expected: "e", "E"
        _failure(_expect7);
      }
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "e" / "E"
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "E"
      _failure(_expect8);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_END_ARRAY() {
    // TERMINAL
    // END_ARRAY <- "]" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "]";  
      _tokenStart = _cursor;  
    }  
    // "]" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "]"
      $$ = _matchChar(93, ']');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "]"
      _failure(_expect9);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_END_OBJECT() {
    // TERMINAL
    // END_OBJECT <- "}" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "}";  
      _tokenStart = _cursor;  
    }  
    // "}" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "}"
      $$ = _matchChar(125, '}');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "}"
      _failure(_expect10);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_EOF() {
    // TERMINAL
    // EOF <- !.
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "EOF";  
      _tokenStart = _cursor;  
    }  
    // !.
    var ch0 = _ch, pos0 = _cursor, testing0 = _testing; 
    _testing = _inputLen + 1;
    // .
    $$ = _matchAny();
    _ch = ch0;
    _cursor = pos0; 
    _testing = testing0;
    $$ = null;
    success = !success;
    if (!success && _cursor > _testing) {
      // Expected: "EOF"
      _failure(_expect11);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_ESCAPE() {
    // TERMINAL
    // ESCAPE <- "\\"
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "\\";  
      _tokenStart = _cursor;  
    }  
    // "\\"
    $$ = _matchChar(92, '\\');
    if (!success && _cursor > _testing) {
      // Expected: "\\"
      _failure(_expect2);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_EXP() {
    // TERMINAL
    // EXP <- E (MINUS / PLUS)? DIGIT+ WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "EXP";  
      _tokenStart = _cursor;  
    }  
    // E (MINUS / PLUS)? DIGIT+ WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // E
      $$ = null;
      success = _ch >= 69 && _ch <= 101 && _lookahead[_ch + 13];
      // Lookahead (E)
      if (success) $$ = _parse_E();    
      if (!success) {    
        // Expected: "E"    
        if (_cursor > _testing) _failure(_expect8);
        break;  
      }
      var seq = new List(4)..[0] = $$;
      // (MINUS / PLUS)?
      var testing0 = _testing;
      _testing = _cursor;
      // MINUS / PLUS
      while (true) {
        // MINUS
        $$ = null;
        success = _ch == 45; // '-'
        // Lookahead (MINUS)
        if (success) $$ = _parse_MINUS();
        if (!success) {
          // Expected: "-"
          if (_cursor > _testing) _failure(_expect12);  
        }
        if (success) break;
        // PLUS
        $$ = null;
        success = _ch == 43; // '+'
        // Lookahead (PLUS)
        if (success) $$ = _parse_PLUS();
        if (!success) {
          // Expected: "+"
          if (_cursor > _testing) _failure(_expect13);  
        }
        break;
      }
      if (!success && _cursor > _testing) {
        // Expected: "-", "+"
        _failure(_expect14);
      }
      success = true; 
      _testing = testing0;
      if (!success) break;
      seq[1] = $$;
      // DIGIT+
      var testing1;
      for (var first = true, reps; ;) {  
        // DIGIT  
        $$ = null;  
        success = _ch >= 48 && _ch <= 57 && _lookahead[_ch + 81];  
        // Lookahead (DIGIT)  
        if (success) $$ = _parse_DIGIT();      
        if (!success) {      
          // Expected: "DIGIT"      
          if (_cursor > _testing) _failure(_expect6);  
        }  
        if (success) {
         if (first) {      
            first = false;
            reps = [$$];
            testing1 = _testing;                  
          } else {
            reps.add($$);
          }
          _testing = _cursor;   
        } else {
          success = !first;
          if (success) {      
            _testing = testing1;
            $$ = reps;      
          } else $$ = null;
          break;
        }  
      }
      if (!success) break;
      seq[2] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[3] = $$;
      $$ = seq;
      if (success) {    
        // E
        final $1 = seq[0];
        // (MINUS / PLUS)?
        final $2 = seq[1];
        // DIGIT+
        final $3 = seq[2];
        // WS
        final $4 = seq[3];
        $$ = _flatten(_compact([$1, $2, $3])).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "EXP"
      _failure(_expect15);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_FALSE() {
    // TERMINAL
    // FALSE <- "false" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "false";  
      _tokenStart = _cursor;  
    }  
    // "false" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "false"
      $$ = _matchString(_strings0, 'false');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "false"
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = false;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "false"
      _failure(_expect16);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_FRAC() {
    // TERMINAL
    // FRAC <- DECIMAL_POINT DIGIT+ WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = ".";  
      _tokenStart = _cursor;  
    }  
    // DECIMAL_POINT DIGIT+ WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // DECIMAL_POINT
      $$ = null;
      success = _ch == 46; // '.'
      // Lookahead (DECIMAL_POINT)
      if (success) $$ = _parse_DECIMAL_POINT();
      if (!success) {
        // Expected: "."
        if (_cursor > _testing) _failure(_expect5);  
        break;  
      }
      var seq = new List(3)..[0] = $$;
      // DIGIT+
      var testing0;
      for (var first = true, reps; ;) {  
        // DIGIT  
        $$ = null;  
        success = _ch >= 48 && _ch <= 57 && _lookahead[_ch + 81];  
        // Lookahead (DIGIT)  
        if (success) $$ = _parse_DIGIT();      
        if (!success) {      
          // Expected: "DIGIT"      
          if (_cursor > _testing) _failure(_expect6);  
        }  
        if (success) {
         if (first) {      
            first = false;
            reps = [$$];
            testing0 = _testing;                  
          } else {
            reps.add($$);
          }
          _testing = _cursor;   
        } else {
          success = !first;
          if (success) {      
            _testing = testing0;
            $$ = reps;      
          } else $$ = null;
          break;
        }  
      }
      if (!success) break;
      seq[1] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // DECIMAL_POINT
        final $1 = seq[0];
        // DIGIT+
        final $2 = seq[1];
        // WS
        final $3 = seq[2];
        $$ = _flatten([$1, $2]).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "."
      _failure(_expect5);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_HEXDIG() {
    // TERMINAL
    // HEXDIG <- DIGIT / [a-f] / [A-F]
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "HEXDIG";  
      _tokenStart = _cursor;  
    }  
    // DIGIT / [a-f] / [A-F]
    while (true) {
      // DIGIT
      $$ = null;
      success = _ch >= 48 && _ch <= 57 && _lookahead[_ch + 81];
      // Lookahead (DIGIT)
      if (success) $$ = _parse_DIGIT();    
      if (!success) {    
        // Expected: "DIGIT"    
        if (_cursor > _testing) _failure(_expect6);
      }
      if (success) break;
      // [a-f]
      $$ = _matchRange(97, 102);
      if (success) break;
      // [A-F]
      $$ = _matchRange(65, 70);
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "HEXDIG"
      _failure(_expect3);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_INT() {
    // TERMINAL
    // INT <- DIGIT+ WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "INT";  
      _tokenStart = _cursor;  
    }  
    // DIGIT+ WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // DIGIT+
      var testing0;
      for (var first = true, reps; ;) {  
        // DIGIT  
        $$ = null;  
        success = _ch >= 48 && _ch <= 57 && _lookahead[_ch + 81];  
        // Lookahead (DIGIT)  
        if (success) $$ = _parse_DIGIT();      
        if (!success) {      
          // Expected: "DIGIT"      
          if (_cursor > _testing) _failure(_expect6);  
        }  
        if (success) {
         if (first) {      
            first = false;
            reps = [$$];
            testing0 = _testing;                  
          } else {
            reps.add($$);
          }
          _testing = _cursor;   
        } else {
          success = !first;
          if (success) {      
            _testing = testing0;
            $$ = reps;      
          } else $$ = null;
          break;
        }  
      }
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // DIGIT+
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = _flatten($1).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "INT"
      _failure(_expect17);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_MINUS() {
    // TERMINAL
    // MINUS <- "-" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "-";  
      _tokenStart = _cursor;  
    }  
    // "-" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "-"
      $$ = _matchChar(45, '-');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "-"
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "-"
      _failure(_expect12);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_NAME_SEPARATOR() {
    // TERMINAL
    // NAME_SEPARATOR <- ":" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = ":";  
      _tokenStart = _cursor;  
    }  
    // ":" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // ":"
      $$ = _matchChar(58, ':');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: ":"
      _failure(_expect18);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_NULL() {
    // TERMINAL
    // NULL <- "null" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "null";  
      _tokenStart = _cursor;  
    }  
    // "null" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "null"
      $$ = _matchString(_strings1, 'null');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "null"
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = null;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "null"
      _failure(_expect19);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_NUMBER() {
    // TERMINAL
    // NUMBER <- MINUS? INT FRAC? EXP? WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "NUMBER";  
      _tokenStart = _cursor;  
    }  
    // MINUS? INT FRAC? EXP? WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // MINUS?
      var testing0 = _testing;
      _testing = _cursor;
      // MINUS
      $$ = null;
      success = _ch == 45; // '-'
      // Lookahead (MINUS)
      if (success) $$ = _parse_MINUS();
      if (!success) {
        // Expected: "-"
        if (_cursor > _testing) _failure(_expect12);  
      }
      success = true; 
      _testing = testing0;
      if (!success) break;
      var seq = new List(5)..[0] = $$;
      // INT
      $$ = null;
      success = _ch >= 48 && _ch <= 57 && _lookahead[_ch + 81];
      // Lookahead (INT)
      if (success) $$ = _parse_INT();    
      if (!success) {    
        // Expected: "INT"    
        if (_cursor > _testing) _failure(_expect17);
        break;  
      }
      seq[1] = $$;
      // FRAC?
      var testing1 = _testing;
      _testing = _cursor;
      // FRAC
      $$ = null;
      success = _ch == 46; // '.'
      // Lookahead (FRAC)
      if (success) $$ = _parse_FRAC();
      if (!success) {
        // Expected: "."
        if (_cursor > _testing) _failure(_expect5);  
      }
      success = true; 
      _testing = testing1;
      if (!success) break;
      seq[2] = $$;
      // EXP?
      var testing2 = _testing;
      _testing = _cursor;
      // EXP
      $$ = null;
      success = _ch >= 69 && _ch <= 101 && _lookahead[_ch + 13];
      // Lookahead (EXP)
      if (success) $$ = _parse_EXP();    
      if (!success) {    
        // Expected: "EXP"    
        if (_cursor > _testing) _failure(_expect15);
      }
      success = true; 
      _testing = testing2;
      if (!success) break;
      seq[3] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[4] = $$;
      $$ = seq;
      if (success) {    
        // MINUS?
        final $1 = seq[0];
        // INT
        final $2 = seq[1];
        // FRAC?
        final $3 = seq[2];
        // EXP?
        final $4 = seq[3];
        // WS
        final $5 = seq[4];
        $$ = _parseNumber($1, $2, $3, $4);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "NUMBER"
      _failure(_expect20);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_PLUS() {
    // TERMINAL
    // PLUS <- "+" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "+";  
      _tokenStart = _cursor;  
    }  
    // "+" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "+"
      $$ = _matchChar(43, '+');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "+"
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = $1;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "+"
      _failure(_expect13);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_QUOTATION_MARK() {
    // TERMINAL
    // QUOTATION_MARK <- "\""
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "\"";  
      _tokenStart = _cursor;  
    }  
    // "\""
    $$ = _matchChar(34, '\"');
    if (!success && _cursor > _testing) {
      // Expected: "\""
      _failure(_expect21);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_STRING() {
    // TERMINAL
    // STRING <- QUOTATION_MARK CHAR* QUOTATION_MARK WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "\"";  
      _tokenStart = _cursor;  
    }  
    // QUOTATION_MARK CHAR* QUOTATION_MARK WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // QUOTATION_MARK
      $$ = null;
      success = _ch == 34; // '"'
      // Lookahead (QUOTATION_MARK)
      if (success) $$ = _parse_QUOTATION_MARK();
      if (!success) {
        // Expected: "\""
        if (_cursor > _testing) _failure(_expect21);  
        break;  
      }
      var seq = new List(4)..[0] = $$;
      // CHAR*
      var testing0 = _testing; 
      for (var reps = []; ; ) {
        _testing = _cursor;
        // CHAR
        $$ = _parse_CHAR();
        if (success) {  
          reps.add($$);
        } else {
          success = true;
          _testing = testing0;
          $$ = reps;
          break; 
        }
      }
      if (!success) break;
      seq[1] = $$;
      // QUOTATION_MARK
      $$ = null;
      success = _ch == 34; // '"'
      // Lookahead (QUOTATION_MARK)
      if (success) $$ = _parse_QUOTATION_MARK();
      if (!success) {
        // Expected: "\""
        if (_cursor > _testing) _failure(_expect21);  
        break;  
      }
      seq[2] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[3] = $$;
      $$ = seq;
      if (success) {    
        // QUOTATION_MARK
        final $1 = seq[0];
        // CHAR*
        final $2 = seq[1];
        // QUOTATION_MARK
        final $3 = seq[2];
        // WS
        final $4 = seq[3];
        $$ = _flatten($2).join();    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "\""
      _failure(_expect21);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_TRUE() {
    // TERMINAL
    // TRUE <- "true" WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "true";  
      _tokenStart = _cursor;  
    }  
    // "true" WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // "true"
      $$ = _matchString(_strings2, 'true');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      if (success) {    
        // "true"
        final $1 = seq[0];
        // WS
        final $2 = seq[1];
        $$ = true;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "true"
      _failure(_expect22);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_UNESCAPED() {
    // TERMINAL
    // UNESCAPED <- [ -!] / [#-\[] / [\]-~] / [\]-\u10ffff]
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "UNESCAPED";  
      _tokenStart = _cursor;  
    }  
    // [ -!] / [#-\[] / [\]-~] / [\]-\u10ffff]
    while (true) {
      // [ -!]
      $$ = _matchRange(32, 33);
      if (success) break;
      // [#-\[]
      $$ = _matchRange(35, 91);
      if (success) break;
      // [\]-~]
      $$ = _matchRange(93, 126);
      if (success) break;
      // [\]-\u10ffff]
      $$ = _matchRange(93, 1114111);
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "UNESCAPED"
      _failure(_expect23);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_VALUE_SEPARATOR() {
    // TERMINAL
    // VALUE_SEPARATOR <- "," WS
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = ",";  
      _tokenStart = _cursor;  
    }  
    // "," WS
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // ","
      $$ = _matchChar(44, ',');
      if (!success) break;
      var seq = new List(2)..[0] = $$;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      seq[1] = $$;
      $$ = seq;
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: ","
      _failure(_expect24);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_WS() {
    // TERMINAL
    // WS <- [\t-\n\r ]*
    var $$;
    if (_tokenLevel++ == 0) {  
      _token = "WS";  
      _tokenStart = _cursor;  
    }  
    // [\t-\n\r ]*
    var testing0 = _testing; 
    for (var reps = []; ; ) {
      _testing = _cursor;
      // [\t-\n\r ]
      $$ = _matchMapping(9, 32, _mapping1);
      if (success) {  
        reps.add($$);
      } else {
        success = true;
        _testing = testing0;
        $$ = reps;
        break; 
      }
    }
    if (!success && _cursor > _testing) {
      // Expected: "WS"
      _failure(_expect25);
    }
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }
    return $$;
  }
  
  dynamic _parse_array() {
    // NONTERMINAL
    // array <- BEGIN_ARRAY (value (VALUE_SEPARATOR value)*)? END_ARRAY
    var $$;
    // BEGIN_ARRAY (value (VALUE_SEPARATOR value)*)? END_ARRAY
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // BEGIN_ARRAY
      $$ = null;
      success = _ch == 91; // '['
      // Lookahead (BEGIN_ARRAY)
      if (success) $$ = _parse_BEGIN_ARRAY();
      if (!success) {
        // Expected: "["
        if (_cursor > _testing) _failure(_expect0);  
        break;  
      }
      var seq = new List(3)..[0] = $$;
      // (value (VALUE_SEPARATOR value)*)?
      var testing0 = _testing;
      _testing = _cursor;
      // value (VALUE_SEPARATOR value)*
      var ch1 = _ch, pos1 = _cursor;
      while (true) {  
        // value
        $$ = null;
        success = _ch >= 34 && _ch <= 123 && _lookahead[_ch + 81];
        // Lookahead (value)
        if (success) $$ = _parse_value();    
        if (!success) {    
          // Expected: "false", "null", "true", "[", "NUMBER", "\"", "{"    
          if (_cursor > _testing) _failure(_expect26);
          break;  
        }
        var seq = new List(2)..[0] = $$;
        // (VALUE_SEPARATOR value)*
        var testing1 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          // VALUE_SEPARATOR value
          var ch2 = _ch, pos2 = _cursor;
          while (true) {  
            // VALUE_SEPARATOR
            $$ = null;
            success = _ch == 44; // ','
            // Lookahead (VALUE_SEPARATOR)
            if (success) $$ = _parse_VALUE_SEPARATOR();
            if (!success) {
              // Expected: ","
              if (_cursor > _testing) _failure(_expect24);  
              break;  
            }
            var seq = new List(2)..[0] = $$;
            // value
            $$ = null;
            success = _ch >= 34 && _ch <= 123 && _lookahead[_ch + 81];
            // Lookahead (value)
            if (success) $$ = _parse_value();    
            if (!success) {    
              // Expected: "false", "null", "true", "[", "NUMBER", "\"", "{"    
              if (_cursor > _testing) _failure(_expect26);
              break;  
            }
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              // VALUE_SEPARATOR
              final $1 = seq[0];
              // value
              final $2 = seq[1];
              $$ = $2;    
            }
            break;  
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          if (!success && _cursor > _testing) {
            // Expected: ","
            _failure(_expect24);
          }
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing1;
            $$ = reps;
            break; 
          }
        }
        if (!success) break;
        seq[1] = $$;
        $$ = seq;
        break;  
      }
      if (!success) {
        _ch = ch1;
        _cursor = pos1;
      }
      if (!success && _cursor > _testing) {
        // Expected: "false", "null", "true", "[", "NUMBER", "\"", "{"
        _failure(_expect26);
      }
      success = true; 
      _testing = testing0;
      if (!success) break;
      seq[1] = $$;
      // END_ARRAY
      $$ = null;
      success = _ch == 93; // ']'
      // Lookahead (END_ARRAY)
      if (success) $$ = _parse_END_ARRAY();
      if (!success) {
        // Expected: "]"
        if (_cursor > _testing) _failure(_expect9);  
        break;  
      }
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // BEGIN_ARRAY
        final $1 = seq[0];
        // (value (VALUE_SEPARATOR value)*)?
        final $2 = seq[1];
        // END_ARRAY
        final $3 = seq[2];
        $$ = _flatten($2).fold([], (p, c) => p..add(c));    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "["
      _failure(_expect0);
    }
    return $$;
  }
  
  dynamic _parse_member() {
    // NONTERMINAL
    // member <- STRING NAME_SEPARATOR value
    var $$;
    // STRING NAME_SEPARATOR value
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // STRING
      $$ = null;
      success = _ch == 34; // '"'
      // Lookahead (STRING)
      if (success) $$ = _parse_STRING();
      if (!success) {
        // Expected: "\""
        if (_cursor > _testing) _failure(_expect21);  
        break;  
      }
      var seq = new List(3)..[0] = $$;
      // NAME_SEPARATOR
      $$ = null;
      success = _ch == 58; // ':'
      // Lookahead (NAME_SEPARATOR)
      if (success) $$ = _parse_NAME_SEPARATOR();
      if (!success) {
        // Expected: ":"
        if (_cursor > _testing) _failure(_expect18);  
        break;  
      }
      seq[1] = $$;
      // value
      $$ = null;
      success = _ch >= 34 && _ch <= 123 && _lookahead[_ch + 81];
      // Lookahead (value)
      if (success) $$ = _parse_value();    
      if (!success) {    
        // Expected: "false", "null", "true", "[", "NUMBER", "\"", "{"    
        if (_cursor > _testing) _failure(_expect26);
        break;  
      }
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // STRING
        final $1 = seq[0];
        // NAME_SEPARATOR
        final $2 = seq[1];
        // value
        final $3 = seq[2];
        $$ = new _KeyValuePair($1, $3);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "\""
      _failure(_expect21);
    }
    return $$;
  }
  
  dynamic _parse_object() {
    // NONTERMINAL
    // object <- BEGIN_OBJECT (member (VALUE_SEPARATOR member)*)? END_OBJECT
    var $$;
    // BEGIN_OBJECT (member (VALUE_SEPARATOR member)*)? END_OBJECT
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // BEGIN_OBJECT
      $$ = null;
      success = _ch == 123; // '{'
      // Lookahead (BEGIN_OBJECT)
      if (success) $$ = _parse_BEGIN_OBJECT();
      if (!success) {
        // Expected: "{"
        if (_cursor > _testing) _failure(_expect1);  
        break;  
      }
      var seq = new List(3)..[0] = $$;
      // (member (VALUE_SEPARATOR member)*)?
      var testing0 = _testing;
      _testing = _cursor;
      // member (VALUE_SEPARATOR member)*
      var ch1 = _ch, pos1 = _cursor;
      while (true) {  
        // member
        $$ = null;
        success = _ch == 34; // '"'
        // Lookahead (member)
        if (success) $$ = _parse_member();
        if (!success) {
          // Expected: "\""
          if (_cursor > _testing) _failure(_expect21);  
          break;  
        }
        var seq = new List(2)..[0] = $$;
        // (VALUE_SEPARATOR member)*
        var testing1 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          // VALUE_SEPARATOR member
          var ch2 = _ch, pos2 = _cursor;
          while (true) {  
            // VALUE_SEPARATOR
            $$ = null;
            success = _ch == 44; // ','
            // Lookahead (VALUE_SEPARATOR)
            if (success) $$ = _parse_VALUE_SEPARATOR();
            if (!success) {
              // Expected: ","
              if (_cursor > _testing) _failure(_expect24);  
              break;  
            }
            var seq = new List(2)..[0] = $$;
            // member
            $$ = null;
            success = _ch == 34; // '"'
            // Lookahead (member)
            if (success) $$ = _parse_member();
            if (!success) {
              // Expected: "\""
              if (_cursor > _testing) _failure(_expect21);  
              break;  
            }
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              // VALUE_SEPARATOR
              final $1 = seq[0];
              // member
              final $2 = seq[1];
              $$ = $2;    
            }
            break;  
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          if (!success && _cursor > _testing) {
            // Expected: ","
            _failure(_expect24);
          }
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing1;
            $$ = reps;
            break; 
          }
        }
        if (!success) break;
        seq[1] = $$;
        $$ = seq;
        break;  
      }
      if (!success) {
        _ch = ch1;
        _cursor = pos1;
      }
      if (!success && _cursor > _testing) {
        // Expected: "\""
        _failure(_expect21);
      }
      success = true; 
      _testing = testing0;
      if (!success) break;
      seq[1] = $$;
      // END_OBJECT
      $$ = null;
      success = _ch == 125; // '}'
      // Lookahead (END_OBJECT)
      if (success) $$ = _parse_END_OBJECT();
      if (!success) {
        // Expected: "}"
        if (_cursor > _testing) _failure(_expect10);  
        break;  
      }
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // BEGIN_OBJECT
        final $1 = seq[0];
        // (member (VALUE_SEPARATOR member)*)?
        final $2 = seq[1];
        // END_OBJECT
        final $3 = seq[2];
        $$ = _flatten($2).fold({}, (p, c) => p..[c.key] = c.value);    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "{"
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_value() {
    // NONTERMINAL
    // value <- FALSE / NULL / TRUE / object / array / NUMBER / STRING
    var $$;
    // FALSE / NULL / TRUE / object / array / NUMBER / STRING
    while (true) {
      // FALSE
      $$ = null;
      success = _ch == 102; // 'f'
      // Lookahead (FALSE)
      if (success) $$ = _parse_FALSE();
      if (!success) {
        // Expected: "false"
        if (_cursor > _testing) _failure(_expect16);  
      }
      if (success) break;
      // NULL
      $$ = null;
      success = _ch == 110; // 'n'
      // Lookahead (NULL)
      if (success) $$ = _parse_NULL();
      if (!success) {
        // Expected: "null"
        if (_cursor > _testing) _failure(_expect19);  
      }
      if (success) break;
      // TRUE
      $$ = null;
      success = _ch == 116; // 't'
      // Lookahead (TRUE)
      if (success) $$ = _parse_TRUE();
      if (!success) {
        // Expected: "true"
        if (_cursor > _testing) _failure(_expect22);  
      }
      if (success) break;
      // object
      $$ = null;
      success = _ch == 123; // '{'
      // Lookahead (object)
      if (success) $$ = _parse_object();
      if (!success) {
        // Expected: "{"
        if (_cursor > _testing) _failure(_expect1);  
      }
      if (success) break;
      // array
      $$ = null;
      success = _ch == 91; // '['
      // Lookahead (array)
      if (success) $$ = _parse_array();
      if (!success) {
        // Expected: "["
        if (_cursor > _testing) _failure(_expect0);  
      }
      if (success) break;
      // NUMBER
      $$ = null;
      success = _ch >= 45 && _ch <= 57 && _lookahead[_ch + 81];
      // Lookahead (NUMBER)
      if (success) $$ = _parse_NUMBER();    
      if (!success) {    
        // Expected: "NUMBER"    
        if (_cursor > _testing) _failure(_expect20);
      }
      if (success) break;
      // STRING
      $$ = null;
      success = _ch == 34; // '"'
      // Lookahead (STRING)
      if (success) $$ = _parse_STRING();
      if (!success) {
        // Expected: "\""
        if (_cursor > _testing) _failure(_expect21);  
      }
      break;
    }
    if (!success && _cursor > _testing) {
      // Expected: "false", "null", "true", "[", "NUMBER", "\"", "{"
      _failure(_expect26);
    }
    return $$;
  }
  
  dynamic parse_jsonText() {
    // NONTERMINAL
    // jsonText <- WS? (object / array) EOF
    var $$;
    // WS? (object / array) EOF
    var ch0 = _ch, pos0 = _cursor;
    while (true) {  
      // WS?
      var testing0 = _testing;
      _testing = _cursor;
      // WS
      $$ = null;
      success = _ch >= 9 && _ch <= 32 && _lookahead[_ch + -9];
      // Lookahead (WS is optional)
      if (success) $$ = _parse_WS();
      else success = true;
      success = true; 
      _testing = testing0;
      if (!success) break;
      var seq = new List(3)..[0] = $$;
      // object / array
      while (true) {
        // object
        $$ = null;
        success = _ch == 123; // '{'
        // Lookahead (object)
        if (success) $$ = _parse_object();
        if (!success) {
          // Expected: "{"
          if (_cursor > _testing) _failure(_expect1);  
        }
        if (success) break;
        // array
        $$ = null;
        success = _ch == 91; // '['
        // Lookahead (array)
        if (success) $$ = _parse_array();
        if (!success) {
          // Expected: "["
          if (_cursor > _testing) _failure(_expect0);  
        }
        break;
      }
      if (!success && _cursor > _testing) {
        // Expected: "{", "["
        _failure(_expect27);
      }
      if (!success) break;
      seq[1] = $$;
      // EOF
      $$ = _parse_EOF();
      if (!success) break;
      seq[2] = $$;
      $$ = seq;
      if (success) {    
        // WS?
        final $1 = seq[0];
        // object / array
        final $2 = seq[1];
        // EOF
        final $3 = seq[2];
        $$ = $2;    
      }
      break;  
    }
    if (!success) {
      _ch = ch0;
      _cursor = pos0;
    }
    if (!success && _cursor > _testing) {
      // Expected: "{", "["
      _failure(_expect27);
    }
    return $$;
  }
  
  void _addToCache(dynamic result, int start, int id) {  
    var cached = _cache[start];
    if (cached == null) {
      _cacheRule[start] = id;
      _cache[start] = [result, _cursor, success];
    } else {    
      var slot = start >> 5;
      var r1 = (slot << 5) & 0x3fffffff;    
      var mask = 1 << (start - r1);    
      if ((_cacheState[slot] & mask) == 0) {
        _cacheState[slot] |= mask;   
        cached = [new List.filled(2, 0), new Map<int, List>()];
        _cache[start] = cached;                                      
      }
      slot = id >> 5;
      r1 = (slot << 5) & 0x3fffffff;    
      mask = 1 << (id - r1);    
      cached[0][slot] |= mask;
      cached[1][id] = [result, _cursor, success];      
    }
    if (_cachePos < start) {
      _cachePos = start;
    }    
  }
  
  void _calculatePos(int pos) {
    if (pos == null || pos < 0 || pos > _inputLen) {
      return;
    }
    _line = 1;
    _column = 1;
    for (var i = 0; i < _inputLen && i < pos; i++) {
      var c = _runes[i];
      if (c == 13) {
        _line++;
        _column = 1;
        if (i + 1 < _inputLen && _runes[i + 1] == 10) {
          i++;
        }
      } else if (c == 10) {
        _line++;
        _column = 1;
      } else {
        _column++;
      }
    }
  }
  
  Iterable _compact(Iterable iterable) {  
    if (iterable is List) {
      var hasNull = false;
      var length = iterable.length;
      for (var i = 0; i < length; i++) {
        if (iterable[i] == null) {
          hasNull = true;
          break;
        }
      }
      if (!hasNull) {
        return iterable;
      }
      var result = [];
      for (var i = 0; i < length; i++) {
        var element = iterable[i];
        if (element != null) {
          result.add(element);
        }
      }
      return result;
    }   
    var result = [];
    for (var element in iterable) {   
      if (element != null) {
        result.add(element);
      }
    }
    return result;  
  }
  
  void _failure([List<String> expected]) {  
    if (_failurePos > _cursor) {
      return;
    }
    if (_cursor > _failurePos) {    
      _expected = [];
     _failurePos = _cursor;
    }
    if (_token != null) {
      _expected.add(_token);
    } else if (expected == null) {
      _expected.add(null);
    } else {
      _expected.addAll(expected);
    }   
  }
  
  List _flatten(dynamic value) {
    if (value is List) {
      var result = [];
      var length = value.length;
      for (var i = 0; i < length; i++) {
        var element = value[i];
        if (element is Iterable) {
          result.addAll(_flatten(element));
        } else {
          result.add(element);
        }
      }
      return result;
    } else if (value is Iterable) {
      var result = [];
      for (var element in value) {
        if (element is! List) {
          result.add(element);
        } else {
          result.addAll(_flatten(element));
        }
      }
    }
    return [value];
  }
  
  dynamic _getFromCache(int id) {  
    var result = _cache[_cursor];
    if (result == null) {
      return null;
    }    
    var slot = _cursor >> 5;
    var r1 = (slot << 5) & 0x3fffffff;  
    var mask = 1 << (_cursor - r1);
    if ((_cacheState[slot] & mask) == 0) {
      if (_cacheRule[_cursor] == id) {      
        _cursor = result[1];
        success = result[2];      
        if (_cursor < _inputLen) {
          _ch = _runes[_cursor];
        } else {
          _ch = EOF;
        }      
        return result;
      } else {
        return null;
      }    
    }
    slot = id >> 5;
    r1 = (slot << 5) & 0x3fffffff;  
    mask = 1 << (id - r1);
    if ((result[0][slot] & mask) == 0) {
      return null;
    }
    var data = result[1][id];  
    _cursor = data[1];
    success = data[2];
    if (_cursor < _inputLen) {
      _ch = _runes[_cursor];
    } else {
      _ch = EOF;
    }   
    return data;  
  }
  
  String _matchAny() {
    success = _cursor < _inputLen;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }    
      if (++_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }    
      return result;
    }    
    return null;  
  }
  
  String _matchChar(int ch, String string) {
    success = _ch == ch;
    if (success) {
      var result = string;  
      if (++_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }    
      return result;
    }  
    return null;  
  }
  
  String _matchMapping(int start, int end, List<bool> mapping) {
    success = _ch >= start && _ch <= end;
    if (success) {    
      if(mapping[_ch - start]) {
        String result;
        if (_ch < 128) {
          result = _ascii[_ch];  
        } else {
          result = new String.fromCharCode(_ch);
        }     
        if (++_cursor < _inputLen) {
          _ch = _runes[_cursor];
        } else {
          _ch = EOF;
        }      
        return result;
      }
      success = false;
    }  
    return null;  
  }
  
  String _matchRange(int start, int end) {
    success = _ch >= start && _ch <= end;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }        
      if (++_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }  
      return result;
    }  
    return null;  
  }
  
  String _matchRanges(List<int> ranges) {
    var length = ranges.length;
    for (var i = 0; i < length; i += 2) {
      if (_ch <= ranges[i + 1]) {
        if (_ch >= ranges[i]) {
          String result;
          if (_ch < 128) {
            result = _ascii[_ch];  
          } else {
            result = new String.fromCharCode(_ch);
          }          
          if (++_cursor < _inputLen) {
            _ch = _runes[_cursor];
          } else {
             _ch = EOF;
          }
          success = true;    
          return result;
        }      
      } else break;  
    }
    success = false;  
    return null;  
  }
  
  String _matchString(List<int> runes, String string) {
    var length = runes.length;  
    success = true;  
    if (_cursor + length < _inputLen) {
      for (var i = 0; i < length; i++) {
        if (runes[i] != _runes[_cursor + i]) {
          success = false;
          break;
        }
      }
    } else {
      success = false;
    }  
    if (success) {
      _cursor += length;      
      if (_cursor < _inputLen) {
        _ch = _runes[_cursor];
      } else {
        _ch = EOF;
      }    
      return string;      
    }  
    return null; 
  }
  
  void _nextChar([int count = 1]) {  
    success = true;
    _cursor += count; 
    if (_cursor < _inputLen) {
      _ch = _runes[_cursor];
    } else {
      _ch = EOF;
    }    
  }
  
  bool _testChar(int c, int flag) {
    if (c < 0 || c > 127) {
      return false;
    }    
    int slot = (c & 0xff) >> 6;  
    int mask = 1 << c - ((slot << 6) & 0x3fffffff);  
    if ((flag & mask) != 0) {    
      return true;
    }
    return false;           
  }
  
  bool _testInput(int flag) {
    if (_cursor >= _inputLen) {
      return false;
    }
    var c = _runes[_cursor];
    if (c < 0 || c > 127) {
      return false;
    }    
    int slot = (c & 0xff) >> 6;  
    int mask = 1 << c - ((slot << 6) & 0x3fffffff);  
    if ((flag & mask) != 0) {    
      return true;
    }
    return false;           
  }
  
  int _toRune(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      throw new StateError("An empty string contains no elements.");
    }
  
    var start = string.codeUnitAt(0);
    if (length == 1) {
      return start;
    }
  
    if ((start & 0xFC00) == 0xD800) {
      var end = string.codeUnitAt(1);
      if ((end & 0xFC00) == 0xDC00) {
        return (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
      }
    }
  
    return start;
  }
  
  List<int> _toRunes(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      return const <int>[];
    }
  
    var runes = <int>[];
    runes.length = length;
    var i = 0;
    var pos = 0;
    for ( ; i < length; pos++) {
      var start = string.codeUnitAt(i);
      i++;
      if ((start & 0xFC00) == 0xD800 && i < length) {
        var end = string.codeUnitAt(i);
        if ((end & 0xFC00) == 0xDC00) {
          runes[pos] = (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
          i++;
        } else {
          runes[pos] = start;
        }
      } else {
        runes[pos] = start;
      }
    }
  
    runes.length = pos;
    return runes;
  }
  
  static List<bool> _unmap(List<int> mapping) {
    var length = mapping.length;
    var result = new List<bool>(length * 31);
    var offset = 0;
    for (var i = 0; i < length; i++) {
      var v = mapping[i];
      for (var j = 0; j < 31; j++) {
        result[offset++] = v & (1 << j) == 0 ? false : true;
      }
    }
    return result;
  }
  
  List<String> get expected {
    var set = new Set<String>();  
    set.addAll(_expected);
    if (set.contains(null)) {
      set.clear();
    }  
    var result = set.toList();
    result.sort(); 
    return result;        
  }
  
  void reset(int pos) {
    if (pos == null) {
      throw new ArgumentError('pos: $pos');
    }
    if (pos < 0 || pos > _inputLen) {
      throw new RangeError('pos');
    }      
    _cursor = pos;
    _cache = new List(_inputLen + 1);
    _cachePos = -1;
    _cacheRule = new List(_inputLen + 1);
    _cacheState = new List.filled(((_inputLen + 1) >> 5) + 1, 0);
    _ch = EOF;  
    _column = -1; 
    _expected = [];
    _failurePos = -1;    
    _line = -1;
    success = true;      
    _testing = -1;
    _token = null;
    _tokenLevel = 0;
    _tokenStart = null;
    if (_cursor < _inputLen) {
      _ch = _runes[_cursor];
    }    
  }
  
  String get unexpected {
    if (_failurePos < 0 || _failurePos >= _inputLen) {
      return '';    
    }
    return new String.fromCharCode(_runes[_failurePos]);  
  }
  
}

